/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.gnmad.model.gdal.implementation;

import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EFactory;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.gnmad.model.gdal.GdalFactory;
import org.gnmad.model.gdal.GdalPropositionValueEnum;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.gnmad.model.gdal.GdalFactory
 * @generated
 */
public class GdalPackageImplementation extends EPackageImpl {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String eNAME = "gdal"; //$NON-NLS-1$

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String eNS_URI = "http://www.gnmad.org/gdal/1.0"; //$NON-NLS-1$

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String eNS_PREFIX = "gdal"; //$NON-NLS-1$

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final GdalPackageImplementation eINSTANCE = org.gnmad.model.gdal.implementation.GdalPackageImplementation
			.init();

	/**
	 * The meta object id for the '{@link org.gnmad.model.gdal.GdalPropositionValueEnum <em>Proposition Value Enum</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.gnmad.model.gdal.GdalPropositionValueEnum
	 * @see org.gnmad.model.gdal.implementation.GdalPackageImplementation#getGdalPropositionValueEnum()
	 * @generated
	 */
	public static final int GDAL_PROPOSITION_VALUE_ENUM = 0;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum gdalPropositionValueEnumEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.gnmad.model.gdal.implementation.GdalPackageImplementation#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private GdalPackageImplementation() {
		super(eNS_URI, ((EFactory) GdalFactory.INSTANCE));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link GdalPackageImplementation#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static GdalPackageImplementation init() {
		if (isInited)
			return (GdalPackageImplementation) EPackage.Registry.INSTANCE
					.getEPackage(GdalPackageImplementation.eNS_URI);

		// Obtain or create and register package
		GdalPackageImplementation theGdalPackage = (GdalPackageImplementation) (EPackage.Registry.INSTANCE
				.get(eNS_URI) instanceof GdalPackageImplementation ? EPackage.Registry.INSTANCE
				.get(eNS_URI) : new GdalPackageImplementation());

		isInited = true;

		// Create package meta-data objects
		theGdalPackage.createPackageContents();

		// Initialize created meta-data
		theGdalPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theGdalPackage.freeze();

		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(GdalPackageImplementation.eNS_URI,
				theGdalPackage);
		return theGdalPackage;
	}

	/**
	 * Returns the meta object for enum '{@link org.gnmad.model.gdal.GdalPropositionValueEnum <em>Proposition Value Enum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Proposition Value Enum</em>'.
	 * @see org.gnmad.model.gdal.GdalPropositionValueEnum
	 * @generated
	 */
	public EEnum getGdalPropositionValueEnum() {
		return gdalPropositionValueEnumEEnum;
	}

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	public GdalFactory getGdalFactory() {
		return (GdalFactory) getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated)
			return;
		isCreated = true;

		// Create enums
		gdalPropositionValueEnumEEnum = createEEnum(GDAL_PROPOSITION_VALUE_ENUM);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized)
			return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Initialize enums and add enum literals
		initEEnum(gdalPropositionValueEnumEEnum,
				GdalPropositionValueEnum.class, "GdalPropositionValueEnum"); //$NON-NLS-1$
		addEEnumLiteral(gdalPropositionValueEnumEEnum,
				GdalPropositionValueEnum.UNDEFINED);
		addEEnumLiteral(gdalPropositionValueEnumEEnum,
				GdalPropositionValueEnum.TRUE);
		addEEnumLiteral(gdalPropositionValueEnumEEnum,
				GdalPropositionValueEnum.FALSE);

		// Create resource
		createResource(eNS_URI);
	}

} //GdalPackageImplementation
